package com.sun.org.apache.xerces.internal.util;

import org.xml.sax.SAXException;
import com.sun.org.apache.xerces.internal.xni.parser.XMLErrorHandler;
import org.xml.sax.SAXParseException;
import org.xml.sax.ErrorHandler;

public abstract class ErrorHandlerProxy implements ErrorHandler
{
    public ErrorHandlerProxy() {
    }
    
    @Override
    public void error(SAXParseException e) throws SAXException {
        XMLErrorHandler eh = this.getErrorHandler();
        if ((eh instanceof ErrorHandlerWrapper)) {
            ((ErrorHandlerWrapper)eh).fErrorHandler.error(e);
        }
        else {
            eh.error("", "", ErrorHandlerWrapper.createXMLParseException(e));
        }
    }
    
    @Override
    public void fatalError(SAXParseException e) throws SAXException {
        XMLErrorHandler eh = this.getErrorHandler();
        if ((eh instanceof ErrorHandlerWrapper)) {
            ((ErrorHandlerWrapper)eh).fErrorHandler.fatalError(e);
        }
        else {
            eh.fatalError("", "", ErrorHandlerWrapper.createXMLParseException(e));
        }
    }
    
    @Override
    public void warning(SAXParseException e) throws SAXException {
        XMLErrorHandler eh = this.getErrorHandler();
        if ((eh instanceof ErrorHandlerWrapper)) {
            ((ErrorHandlerWrapper)eh).fErrorHandler.warning(e);
        }
        else {
            eh.warning("", "", ErrorHandlerWrapper.createXMLParseException(e));
        }
    }
    
    protected abstract XMLErrorHandler getErrorHandler();
}
